angular.module('quizApp.controllers', []).controller('BibleController', function($scope, $stateParams, QuizFactory, $filter, $rootScope) {
  QuizFactory.bibles().then(function(data) {
    //alert('allQuizes: '+JSON.stringify(data));
    $rootScope.Bibles = [];
    for (var i = 0; i < Object.keys(data).length; i++) {
      //alert('quiz ' + i + ' :: ' + JSON.stringify(data[i]));
      $rootScope.Bibles.push(data[i]);
    }
    $scope.Bibles = $rootScope.Bibles;
    //alert($scope.Quizes);
  });
}).controller('IndexController', function($scope, $stateParams, QuizFactory, $filter, $rootScope) {
  if($stateParams.code!=undefined){
    $rootScope.selectedBible = $stateParams.code;
  }
  if($stateParams.title!=undefined){
    $rootScope.selectedBibleTitle = $stateParams.title;
  }
  QuizFactory.allQuizes($rootScope.selectedBible).then(function(data) {
    //alert('allQuizes: '+JSON.stringify(data));
    $rootScope.Quizes = [];
    for (var i = 0; i < Object.keys(data).length; i++) {
      //alert('quiz ' + i + ' :: ' + JSON.stringify(data[i]));
      $rootScope.Quizes.push(data[i]);
    }
    $scope.Quizes = $rootScope.Quizes;
    //alert($scope.Quizes);
  });
}).controller('QuizController', function($scope, $stateParams, QuizFactory, $filter, usSpinnerService, $rootScope, $location, $window) {
  QuizFactory.quizById($stateParams.id, $rootScope.selectedBible).then(function(data) {
    //alert('quiz: ' + $stateParams.id + " :: " +JSON.stringify(data));
    $scope.Quiz = data
      //alert($scope.Quiz);
    $scope.Quiz.currentQuestion = '';
    $scope.Quiz.currentQuestionIndex = -1;
    $scope.Quiz.totalQuestions = $scope.Quiz.questions.length;
    $scope.nextQuestion();
    usSpinnerService.stop('spinner-1');
  });

  /**
   * Navigate to and display the next question
   */
  $scope.nextQuestion = function() {
    // Fail if the user did NOT select an answer ?
    if ($scope.Quiz.currentQuestion && ($scope.Quiz.currentQuestion.selected === undefined)) {
      $window.alert("Before you can continue, please select your answer!");
      return;
    }
    $scope.Quiz.currentQuestionIndex = $scope.Quiz.currentQuestionIndex + 1;
    $scope.Quiz.currentQuestion = $scope.Quiz.questions[$scope.Quiz.currentQuestionIndex];
    $scope.Quiz.currentQuestion.no = $scope.Quiz.currentQuestionIndex + 1;
  }

  /**
   * Navigate to and display the next question
   */
  $scope.previousQuestion = function() {
    $scope.Quiz.currentQuestionIndex = $scope.Quiz.currentQuestionIndex - 1;
    $scope.Quiz.currentQuestion = $scope.Quiz.questions[$scope.Quiz.currentQuestionIndex];
    $scope.Quiz.currentQuestion.no = $scope.Quiz.currentQuestionIndex + 1;
  }

  $scope.submitQuiz = function() {
    $rootScope.score = QuizFactory.getTheScore($scope.Quiz);
		$location.path("/quizresults");
  }

}).controller('ContactUsController',function($scope,$state,$stateParams,QuizFactory,$timeout){
    $scope.yourname = '';
    $scope.youremail = '';
    $scope.yourmobile = '';
    $scope.yourmessage = '';
    $scope.message = '';
    $scope.sendContactUs=function(){
        $scope.addSuccess = false;
        $scope.addError = false;
        var dataObj = {
            fullname : $scope.yourname,
            email : $scope.youremail,
            mobile : $scope.yourmobile,
            message : $scope.yourmessage,
            bookname : $APP_NAME,
            bookurl : $APP_WEB_URL
    		};
        var res = QuizFactory.sendContactUs(dataObj);
        res.success(function(data, status, headers, config) {
          $scope.addSuccess = true;
		  $scope.yourname = '';
          $scope.youremail = '';
          $scope.yourmobile = '';
          $scope.yourmessage = '';
          $state.go('contactUs');
		  $timeout(function(){
			$scope.addSuccess = false;
		  }, 3000); // maybe '}, 3000, false);' to avoid calling apply
		});
        res.error(function(data, status, headers, config) {
          $scope.addError = true;
          $scope.message = JSON.stringify({data: data});
        });
    }

}).controller('AboutUsController', function($scope, $stateParams, QuizFactory, $filter, $rootScope) {

}).controller('ScoreController', function($scope, $stateParams, QuizFactory, $filter, $rootScope) {
  $scope.title  = $rootScope.score ? $rootScope.score.quizName   : 0;
	$scope.grade  = $rootScope.score ? $rootScope.score.totalScore : 0;
	$scope.scores = $rootScope.score ? $rootScope.score.items      : [ ];
});
